#include "normalisation.h"

#include <float.h>
#include <stdio.h>
#include <math.h>

CvPoint2D64d *Tpoint;
int nbpoint;

CvPoint2D64d Calcul_Intersection(CvPoint2D64d pt11,CvPoint2D64d pt12,CvPoint2D64d pt21,CvPoint2D64d pt22)
{
	double a1,a2,b1,b2;
	CvPoint2D64d pt;

	a1 = (pt11.y-pt12.y)/(pt11.x-pt12.x);
	a2 = (pt21.y-pt22.y)/(pt21.x-pt22.x);
	if(a1 == a2 || pt11.x==pt12.x || pt11.y == pt12.y || pt21.x==pt22.x || pt21.y == pt22.y)
	{
		pt.x=-1;
		pt.y=-1;
	}
	else
	{	
		b1 = pt12.y-a1*pt12.x;
		b2 = pt22.y-a2*pt22.x;

		pt.x = (b2-b1)/(a1-a2);
		pt.y = a1*pt.x + b1;
		pt.y = a2*pt.x + b2;
	}
	return pt;
}
double Distancel(CvPoint2D64d pt1,CvPoint2D64d pt2)
{
	return sqrt(  (pt1.x-pt2.x)*(pt1.x-pt2.x) + (pt1.y-pt2.y)*(pt1.y-pt2.y));
}

void Convergence(IplImage* tmp,IplImage* image,CvPoint2D64d *scanline,int size,int offset_X)
{
	int i;
	CvPoint2D64d pt11,pt12,pt21,pt22;
	/* Parcours de toutes les scanlines */
#if 1
	for(i=1;i<size/2-1;i+=20)
	{
	/* Scanline BAS de l'image */
		pt11 = scanline[i+0];
		pt12 = scanline[i+1];
		if(tmp)
		{
			/* Vert */
			cvCircle(tmp, cvPoint((int)pt11.x + ((offset_X > 0) ? tmp->width/2 : 0),(int)(pt11.y+tmp->height/2)), 5, CV_RGB(0,255,0), CV_FILLED);	
			/* Bleu */
			cvCircle(tmp, cvPoint((int)pt12.x + ((offset_X > 0) ? tmp->width/2 : 0),(int)(pt12.y+tmp->height/2)), 5, CV_RGB(0,0,255), CV_FILLED);	
			/* Rouge */
			cvLine(tmp,	cvPoint((int)pt11.x,(int)pt11.y+tmp->height/2),
						cvPoint((int)pt12.x,(int)pt12.y+tmp->height/2), CV_RGB(255,0,0), 1, 8 );
		}
	/* Scanline HAUT de l'image */
		pt21 = scanline[size-(i+0)];
		pt22 = scanline[size-(i+1)];
		if(tmp)
		{
			/* Vert */
			cvCircle(tmp, cvPoint((int)pt21.x + ((offset_X > 0) ? tmp->width/2 : 0),(int)(pt21.y+tmp->height/2)), 5, CV_RGB(0,255,0), CV_FILLED);	
			/* Bleu */
			cvCircle(tmp, cvPoint((int)pt22.x + ((offset_X > 0) ? tmp->width/2 : 0),(int)(pt22.y+tmp->height/2)), 5, CV_RGB(0,0,255), CV_FILLED);	
			/* Jaune */
			cvLine(tmp, cvPoint((int)pt21.x,(int)pt21.y+tmp->height/2),
						cvPoint((int)pt22.x,(int)pt22.y+tmp->height/2), CV_RGB(255,255,0), 1, 8 );
		}
	/* Alongement des droites */
		/* Alongement de la scanline au dl de l'image 
		a = (pt11.y-pt12.y)/(pt11.x-pt12.x);
		b = pt11.y - a*pt11.x;
		pt11.x = tmp->width  ;
		pt11.y = a*pt11.x + b;
		/* Rouge 
		cvLine(tmp,	cvPoint((int)pt11.x,(int)pt11.y+tmp->height/2),
					cvPoint((int)pt12.x,(int)pt12.y+tmp->height/2), CV_RGB(255,0,0), 1, 8 );
		/* Alongement de la scanline au dl de l'image 
		a = (pt21.y-pt22.y)/(pt21.x-pt22.x);
		b = pt21.y - a*pt21.x;
		pt21.x = tmp->width  ;
		pt21.y = a*pt21.x + b;
		/* Jaune 
		cvLine(tmp, cvPoint((int)pt21.x,(int)pt21.y+tmp->height/2),
					cvPoint((int)pt22.x,(int)pt22.y+tmp->height/2), CV_RGB(255,255,0), 1, 8 );

	/* Calcul de la convergence courante */
		if(pt11.x == 377 && pt11.y == 134)
			pt11.x = 377;
		if( (Distancel(pt11,pt12) < (image->height/2)) || (Distancel(pt21,pt22) < (image->height/2)) )
			continue;
		Tpoint = realloc(Tpoint,sizeof(CvPoint2D64d)*(nbpoint+1));
		pt11 = Calcul_Intersection(pt11,pt12,pt21,pt22);
		if(pt11.x ==-1 && pt11.y==-1)
			continue;
		Tpoint[nbpoint] = pt11;
		//Tpoint[nbpoint] = Calcul_Intersection(pt11,pt12,pt21,pt22);
		//cvCircle(tmp,cvPoint((int)Tpoint[nbpoint].x,(int)Tpoint[nbpoint].y+tmp->height/2),5,CV_RGB(255,255,255),CV_FILLED);	/* Rouge */
		//cvShowImage("Norm",tmp);
		//cvWaitKey(0);
		nbpoint++;
#else
	for(i=0;i<size;i+=50)
	{
		int k = i/50;
        int r,g,b;
        b = (((k%7)+1)&1)*255;
        g = ((((k%7)+1)&2)>>1)*255;
        r = ((((k%7)+1)&4)>>2)*255;

		for(j=0;j<50;j+=2)
		{
			/* Vert */
			cvCircle(tmp,cvPoint((int)scanline[(i+j+0)].x,(int)(scanline[(j+i+0)].y+tmp->height/2)),5,CV_RGB(0,255,0),CV_FILLED);	
			/* Bleu */
			cvCircle(tmp,cvPoint((int)scanline[(i+j+1)].x,(int)(scanline[(j+i+1)].y+tmp->height/2)),5,CV_RGB(0,0,255),CV_FILLED);	
			cvLine(tmp,	cvPoint((int)scanline[(i+j)].x,(int)scanline[(i+j)].y+tmp->height/3),
						cvPoint((int)scanline[(i+j+1)].x,(int)scanline[(i+j+1)].y+tmp->height/2),CV_RGB(r,g,b ),1,8);//CV_RGB((i+j)*255/size,(i+j)*255/size,(i+j)*255/size),1,8 );
		}
#endif


	}
	return;
}
CvPoint2D64d Barycentre(CvPoint2D64d *scanline,int size)
{
	int i;
	int index;
	double min,d;
	CvPoint2D64d tmp;
	/* Calcul du barycentre */
	tmp.x = 0;
	tmp.y = 0;
	for(i=0;i<nbpoint;i++)
	{
		tmp.x += Tpoint[i].x;
		tmp.y += Tpoint[i].y;
	}
	tmp.x /= nbpoint;
	tmp.y /= nbpoint;
	/* Minimisation des distance */
	min = DBL_MAX;
	for(i=0;i<nbpoint;i++)
	{
		d = Distancel(Tpoint[i],tmp);
		if(d < min)
		{
			min = d;
			index = i;
		}
	}
	return Tpoint[index];
}


CvPoint2D64d *Interpolation(CvPoint2D64d *scanline,int *size,int factor)
{
	CvPoint2D64d *tab;
	int nb,i,j ;
//	*size=50;
	nb = *size;
	tab = calloc(nb*2,sizeof(CvPoint2D64d));
	for(i=0,j=0;i<nb/2;i+=2,j+=4)
	{
		printf("(%d) %g %g\n",i,scanline[i].x,scanline[i].y);
		printf("(%d) %g %g\n",i+1,scanline[i+1].x,scanline[i+1].y);
		tab[j].x = scanline[i].x;
		tab[j].y = scanline[i].y;
		tab[j+1].x = scanline[i+1].x;
		tab[j+1].y = scanline[i+1].y;
	}
	printf("aprs\n");
	for(i=2;i<nb;i+=4)
	{
		tab[i].x = (tab[i-2].x + tab[i+2].x)/2;
		tab[i].y = (tab[i-2].y + tab[i+2].y)/2;
		tab[i+1].x = (tab[i+1-2].x + tab[i+1+2].x)/2;
		tab[i+1].y = (tab[i+1-2].y + tab[i+1+2].y)/2;
	}
	for(i=0;i<nb;i++)
	{
		printf("(%d) %g %g\n",i,tab[i].x,tab[i].y);
	}
	return tab;
#if 0
	int i;
	FILE * File;
	int nb ;
	CvPoint2D64d *tab;
	File = fopen("point.txt","w");
	
	*size=50;
	nb = *size;
	tab = malloc(sizeof(CvPoint2D64d)*nb*2);
	fprintf(File,"avt copie\n");
	for(i=0;i<nb/2;i++)
		fprintf(File,"%d %g %g\n",i,scanline[i].x,scanline[i].y);
	/* Ajout de place */
	for(i=2;i<nb/2;i+=4)
	{
		scanline = realloc(scanline,sizeof(CvPoint2D64d)*(nb+2));
		memcpy(scanline+i+2,scanline+i,sizeof(CvPoint2D64d)*(nb-i));
		scanline[i].x = 0;
		scanline[i].y = 0;
		scanline[i+1].x = 0;
		scanline[i+1].y = 0;
		nb*=2;
		printf("%d (%d) (%d)\n",i,nb,nb/2);
	}
	*size=nb;
	fprintf(File,"aprs copie avec 0\n");
	for(i=0;i<nb/2;i++)
		fprintf(File,"%d %g %g\n",i,scanline[i].x,scanline[i].y);

	/* interpolation */
	for(i=2;i<nb/2;i+=4)
	{
		scanline[i].x = (scanline[i-2].x + scanline[i+2].x)/2;
		scanline[i].y = (scanline[i-2].y + scanline[i+2].y)/2;
		scanline[i+1].x = (scanline[i+1-2].x + scanline[i+1+2].x)/2;
		scanline[i+1].y = (scanline[i+1-2].y + scanline[i+1+2].y)/2;
	}


	fprintf(File,"aprs copie\n");
	for(i=0;i<nb/2;i++)
		fprintf(File,"%d %g %g\n",i,scanline[i].x,scanline[i].y);
	fclose(File);
#endif
}

IplImage *Normalisation(IplImage *image,CvPoint2D64d *scanline,int size,int offset_X,IplImage *img,FILE *Out)
{
	int i,j;
	static IplImage *tmp=NULL;
	CvPoint2D64d pt;
	uchar R,G,B;
	double min,max,d,dA,dB,u,ximage,yimage,x1,x2,y,xtmp;
	int indexmin,indexmax;
	nbpoint = 0;
	Tpoint = NULL;
	if(!offset_X)
	{
		cvReleaseImage(&tmp);
		tmp = NULL;
	}
	if(!tmp)
	{
		tmp = cvCreateImage(cvSize(image->width*4,image->height*4),image->depth,image->nChannels);
		cvSetZero(tmp);
	}
//	printf("Nombre de scanline : %d\n",size);
//	cvNamedWindow("Norm",0);

//	for(i=0;i<size-1;i++)
//	{
//		if(scanline[i].x > scanline[i+1].x)
//		{
//			pt = scanline[i];
//			scanline[i] = scanline[i+1];
//			scanline[i+1] = pt;
//		}
//	}
	/* Interpolation des scanlines */
//	scanline = Interpolation(scanline,&size,4);
	/* Recopie de l'image (au tiers de l'image 
	for(i=0;i<image->height;i++)
		for(j=0;j<image->width*3;j++)
		{
			tmp->imageData[j+((X > 0) ?tmp->widthStep/2:0)+((i+tmp->height/2)*tmp->widthStep)] = image->imageData[j+i*image->widthStep];
		}
	/* Calcul des points de convergence */
	Convergence(tmp,image,scanline,size,offset_X);
	if(!nbpoint)
		return NULL;
	/* Calcul du barycentre */
   	pt = Barycentre(scanline,size);
	fprintf(Out,"Point de convergence des scanlines : %g %g\n",pt.x,pt.y);
	cvCircle(tmp,cvPoint((int)pt.x,(int)pt.y+tmp->height/2),5,CV_RGB(255,255,255),CV_FILLED);	/* Blanc */
	free(Tpoint);
	/* Calcul des distances min et max */
	min = +DBL_MAX;
	max = -DBL_MAX;
	for(i=0;i<size;i++)
	{
		d = Distancel(scanline[i],pt);
		if(d<min)
		{
			min = d;
			indexmin = i;
		}
		if(d>max)
		{
			max = d;
			indexmax = i;
		}
	}
	/* Vert 
	cvCircle(tmp, cvPoint((int)scanline[indexmin].x,(int)(scanline[indexmin].y+tmp->height/2)), 5, CV_RGB(0,255,0), CV_FILLED);	
	/* Bleu 
	cvCircle(tmp, cvPoint((int)scanline[indexmax].x,(int)(scanline[indexmax].y+tmp->height/2)), 5, CV_RGB(0,0,255), CV_FILLED);	
	/* Redressement des scanlines */
	cvReleaseImage(&img);
	img = cvCreateImage(cvSize((int)(fabs(max-min)),(int)(size/2+1)),image->depth,image->nChannels);
	cvSetZero(img);
	for(i=0;i<size;i+=2)
	{
		/* Calcul de la nouvelle scanline */
		dA = Distancel(scanline[i],pt);
		dB = Distancel(scanline[i+1],pt);
		x1 = (max-dA);
		x2 = (max-dB);
		//y = (((size/2)-i)*image->height/(size/2));
		//y = (size/2)-i/2;
		//y = i/2;		/* dvt derrier */
		if(pt.x > 0)
			y = size/2-i/2;
		else
		{
			y = i/2;
			xtmp = x1;
			x1 = x2;
			x2 = xtmp;
		}
		/* Affichage des scanlines */
		cvLine(tmp,	cvPoint((int)x1+((offset_X>0)?tmp->width/2:0),(int)y),
					cvPoint((int)x2+((offset_X>0)?tmp->width/2:0),(int)y),CV_RGB(255,0,0),1,8 );
#if 1
		{
			for(j=(int)MIN(x2,x1);j<MAX(x1,x2);j++)
			{
				/* Facteur paramtrique */
				u = (j-x1)/(x2-x1);
				/* Coordonnees correspondante */
				ximage = scanline[i].x*(1-u) + scanline[i+1].x*u;
				yimage = scanline[i].y*(1-u) + scanline[i+1].y*u;
				if(ximage <0 || yimage < 0 || ximage > image->width || yimage > image->height  )
					continue;
				/* Pixel correspondant */					
				if(ximage >=0 && ximage < image->width && yimage >=0 && yimage < image->width)
					IplGetPixel(image,(int)ximage,(int)yimage,&R,&G,&B);
//				else
//					printf("Indice negatifs : ximage:%d yimage:%d\n",ximage,yimage);
				if( j >=0 && j < img->width && y >=0 && y < img->height)
					IplSetPixel(img,(int)j,(int)y,R,G,B,0);
//				else
//					printf("Indice negatifs : j:%d y:%d\n",j,y);
			}
		}
#endif
#if 0
		// Paramtrique v1
		{
			double xtmp,ytmp;
			for(u=0;u<1;u+=0.001)
			{
				/* Parcours paramtrique de l'ancienne scanline */
				ximage = (scanline[i].x)*(1-u) + (scanline[i+1].x)*(u);
				yimage = scanline[i].y*(1-u) + scanline[i+1].y*(u);
				/* Parcours paramtrique de la nouvelle scanline */
				xtmp = (x1)*(1-u) + (x2)*(u);
				/* Recopie du pixel */
				IplGetPixel(image,(int)ximage,(int)yimage,&R,&G,&B);
				IplSetPixel(tmp,(int)xtmp,(int)ytmp,R,G,B,((offset_X > 0) ?tmp->widthStep/2:0));
				IplSetPixel(img,(int)xtmp,(int)y,R,G,B,0);
			}
		}
#endif
	}
//	cvShowImage("Norm",tmp);
	return img;
}

Vecteur MakeVecteur(CvPoint3D64d pt1,CvPoint3D64d pt2)
{
	Vecteur v;
	v.x = pt1.x - pt2.x;
	v.y = pt1.y - pt2.y;
	v.z = pt1.z - pt2.z;
	return v;
}
double Scalaire(Vecteur v1,Vecteur v2)
{
	return (v1.x*v2.x + v1.y*v2.y + v1.z*v2.z);
}
double Norme(Vecteur v)
{
	return sqrt( v.x*v.x + v.y*v.y + v.z*v.z);
}
double Norme2(CvPoint3D64d pt1,CvPoint3D64d pt2)
{
	return sqrt( (pt1.x-pt2.x)*(pt1.x-pt2.x) + (pt1.y-pt2.y)*(pt1.y-pt2.y) + (pt1.y-pt2.y)*(pt1.y-pt2.y));
}
Vecteur Vectoriel(Vecteur v1,Vecteur v2)
{
	Vecteur v;
	v.x = v1.y*v2.z - v1.z*v2.y;
	v.y = v1.z*v2.x - v1.x*v2.z;
	v.z = v1.x*v2.y - v1.y*v2.x;
	return v;
}

CvPoint3D64d Projection(CvPoint3D64d O,CvPoint2D64d pt,double d)
{
	double distO,den;
	CvPoint3D64d new_pt3D;
	CvPoint2D64d new_pt;
	/* Calcul du correspondant en 3D */
	distO = O.x * O.x + O.y * O.y + O.z * O.z;
	den  = O.x*pt.x + O.y*pt.y + O.z*d;
	new_pt3D.x  = ( distO * pt.x ) / den;
	new_pt3D.y  = ( distO * pt.y ) / den;
	new_pt3D.z  = ( distO * d ) / den;
	fprintf(Out,"%g %g ==> %g %g %g\n",pt.x,pt.x,new_pt3D.x,new_pt3D.y,new_pt3D.z);
	return new_pt3D;
}

IplImage *NormalisationV2(IplImage *image,CvPoint2D64d *scanline,int size,int offset_X,IplImage *img,FILE *Out)
{
	int i,j;
	static int indic = 0;
	double d;
	double distI;
	char buffer[64];
	uchar R,G,B,R1,G1,B1;
	IplImage *tmp,*tmp1;
	CvPoint3D64d C,I,O,Os,M,Ms,Imagept,Imagepts,pt3D;
	CvPoint2D64d pt;
	printf("Normalisation\n");
	Convergence(NULL,image,scanline,size,offset_X);
	printf("nombre de point de convergence : %d\n",nbpoints);
	pt = Barycentre(scanline,size);
	printf("Point de convergende : %g %g\n",pt.x,pt.y);
	/* Initialisation des points connus */
	d = 5;
	C.x = C.y = C.z = 0;
	O.x = O.y = 0;
	O.z = d;
	I.x = pt.x;
	I.y = pt.y;
	I.z = d;
	/* Calcul du second centre de projection */
	distI = I.x*I.x + I.y*I.y + d*d;
	Os.x = (-d * d * I.x) / (distI);
	Os.y = (-d * d * I.y) / (distI);
	Os.z = ( d *   (I.x * I.x + I.y * I.y) ) / (distI);
	tmp = cvCreateImage(cvSize(image->width*3,image->height*3), image->depth,image->nChannels);
	tmp1 = cvCreateImage(cvSize(image->width*2,image->height*2), image->depth,image->nChannels);
	cvSetZero(tmp);
	cvNamedWindow("Normalisation", 0);
	/* Calcul et application de la transformation sur toute l'image */
	for(i=0;i<image->height;i++)
	{
		for(j=0;j<image->width;j++)
		{
			IplGetPixel(image,j,i,&R,&G,&B);
			pt.x = j;
			pt.y = i;
			/* Calcul de la projection */
			pt3D = Projection(O,pt, d);
			/* Calcul de la tranformation */
			
			pt .x = Scalaire(MakeVecteur(C,pt3D),MakeVecteur(I,C)) / Norme(MakeVecteur(I,C));
			pt .y = Scalaire(MakeVecteur(C,pt3D),Vectoriel(MakeVecteur(C,Os),MakeVecteur(I,C))) / (Norme(MakeVecteur(C,Os))*Norme(MakeVecteur(I,C)));
			pt.x *=-1;
			//pt.y *=-1;
			//printf("%g %g\n",pt.x,pt.y);
			/* Recopie de l'image de base */
			IplSetPixel(tmp,(int)j,(int)i,R,G,B,0);
			/* Recopie de l'image transforme */
			if(pt.x >= 0 && pt.y >= 0 && pt.x < tmp->height && pt.y < tmp->width)
			{
				IplSetPixel(tmp,(int)pt.x,(int)pt.y,R,G,B,1*tmp->width/3);	
				IplSetPixel(tmp1,(int)pt.x,(int)pt.y,R,G,B,1*tmp->width/3);	
			}
			fprintf(Out,"%d %d ==> %g %g\n",j,i,pt.x,pt.y);
		}
	}
	cvShowImage("Normalisation",tmp);
	cvWaitKey(0);
	sprintf(buffer,"image%d.bmp",indic);
	cvSaveImage(buffer,tmp1);
	
	indic++;
}












