#include "tools.h"

/* Nom des fichiers utilises			*/
char Name[][2][128]	= {	{"./img/basket1.bmp", "./img/basket2.bmp"}, 
						{"./img/BureauL.bmp", "./img/BureauR.bmp"}, 
						{"./img/carreL.bmp", "./img/carreR.bmp"}, 
						{"./img/cheeriosL.bmp", "./img/cheeriosR.bmp"}, 
						{"./img/cloroxL.png", "./img/cloroxR.png"}, 
						{"./img/statue1.bmp", "./img/statue2.bmp"}, 
						{"./img/TruckL.bmp", "./img/TruckR.bmp"}, 
						{"./img/tsukubaL.png", "./img/tsukubaR.png"}, 
						{"./img/umbrellaL.png", "./img/umbrellaR.png"},
						{"./img/HD.0010.tga", "./img/HD.0012.tga"},
						{"./img/droite.bmp", "./img/gauche.bmp"},
						{"./img/droite1.bmp", "./img/gauche1.bmp"},
						{"./img/gare-left.png", "./img/gare-right.png"},
						{"./img/PICT0011.JPG", "./img/PICT0011.JPG"},
						{"./img/sofi_right1.png", "./img/sofi_left1.png"},
						{"./img/sofi_right2.png", "./img/sofi_left2.png"},
						{"./img/SD.0010.tga", "./img/SD.0012.tga"}};

char Name_output[2][64]={	{"sortie1.bmp"},
						{"sortie2.bmp"}
						};

IplImage *Resolution(IplImage *img,float fact)
{
	IplImage *tmp;
	tmp = cvCreateImage(cvSize(img->width*factor,img->height*factor),img->depth,img->nChannels);
	cvResize(img,tmp,CV_INTER_NN);
	return tmp;
}

void Arguments(int *argc,char **argv)
{
	void *options;
	char *buffer;
	int i;
	/* Recherche des noms de fichiers */
	for(i=0;i<*argc ; i++)
	{
		if(strcmp(argv[i],"-f")==0)
			break;
	}
	if(i < *argc)
	{
		/* Lecture des noms de fichiers */
		strcpy(Name[File][LEFT],   argv[i+1]);
		strcpy(Name[File][RIGHT],  argv[i+2]);
		strcpy(Name_output[LEFT],  argv[i+3]);
		strcpy(Name_output[RIGHT], argv[i+4]);
	}
	/* Recherche des paramtres de mode et nombre */
	options=gopts("nmdp",argc,&argv);					// m:mode		n:nombre		d:debug	p:partition
	/* Gestion du nombre de points */
	if(gopt(options,'n',"mode",&buffer))
		nbpoints = atoi(buffer);
	/* Gestion du Debug */
	if(gopt(options,'d',"mode",&buffer))
	{
		if(strcmp(buffer,"yes")==0)
		{
			Debug = 1;
			Out = stderr;
		}
		else
		{
			Debug = 0;
			Out = fopen("log.txt","w");
		}
	}
	else
	{
		Debug = 0;
		Out = fopen("log.txt","w");
	}
	if(Out == NULL)
		printf("Descripteur non ouvert\n");
	/* Gestion du mode de reprsentation */
	if(gopt(options,'m',"mode",&buffer))
	{
		switch(buffer[0])
		{
			case 'g' :
				Mode = GRAPHIC;
				fprintf(Out,"Mode graphique active\n");
				break;
			case 't' :
				Mode = TEXTE;
				fprintf(Out,"Mode texte active\n");
				break;
		}
	}
	else
		Mode = GRAPHIC;
	if(gopt(options,'p',"partition",&buffer))
	{
		partition = atoi(buffer);
	}

}
void IplSetPixel(IplImage *image,int i_X, int i_Y,uchar R,uchar G,uchar B,int offsetX)
{
	if(i_Y <0 || i_X<0)
		printf("Indices ngatifs : %d %d\n",i_X,i_Y);
	((uchar*)(image->imageData + 	image->widthStep*i_Y))[(i_X+offsetX)*3 ] = B;
	((uchar*)(image->imageData + 	image->widthStep*i_Y))[(i_X+offsetX)*3+1] = G;
	((uchar*)(image->imageData + 	image->widthStep*i_Y))[(i_X+offsetX)*3+2] = R;
}
void IplGetPixel(IplImage *image,int i_X, int i_Y,uchar *R,uchar *G,uchar *B)
{
	if(i_Y <0 || i_X<0)
		printf("Indices ngatifs : %d %d\n",i_X,i_Y);
	*B = ((uchar*)(image->imageData + 	image->widthStep*i_Y))[i_X*3 ];
	*G = ((uchar*)(image->imageData + 	image->widthStep*i_Y))[i_X*3+1];
	*R = ((uchar*)(image->imageData + 	image->widthStep*i_Y))[i_X*3+2];
}

void InitTrackerBlock(Image *img, int *nbpoints, int nb)
{
	Image *part;
//	char buffer[64];
	int i,j,I,J,offsetX,offsetY;
	int cpt,sub,total=0,tmp;
	uchar R,G,B;
	sub = (int)sqrt(nb);
	part = (Image*)malloc(sizeof(Image)*nb);
	/* Cration des imagettes et lancement du tracking */
	for(I=0,cpt=0;I<sub;I++)
		for(J=0;J<sub;J++)
		{
			fprintf(Out,"part %d %d\n",I,J);
//			sprintf(buffer,"part %d %d",I,J);
//			cvNamedWindow(buffer,1);
			part[cpt].img = cvCreateImage(cvSize((img->img->width/sub),(img->img->height/sub)),img->img->depth,img->img->nChannels);
			cvSetZero(part[cpt].img);
			for(i=0;i<part[cpt].img->height;i++)
			{
				for(j=0;j<part[cpt].img->width;j++)
				{
					offsetX = J*img->img->width/sub;
					offsetY = I*img->img->height/sub;

					if(i+offsetY >= 0 && j+offsetX >= 0 && i+offsetY < img->img->height && j+offsetX < img->img->width )
						IplGetPixel(img->img,j+offsetX,i+offsetY,&R,&G,&B);
					if( i>=0 && j >= 0 && i<part[cpt].img->height && j<part[cpt].img->width)
						IplSetPixel(part[cpt].img,j,i,R,G,B,0);
				}
			}
			part[cpt].tracker = malloc(sizeof(Tracker));
			InitCriteria(part[cpt].tracker);
			tmp = *nbpoints;
			InitTracker(part[cpt].img,part[cpt].tracker,&tmp,&part[cpt].score);
			total += tmp;
//			for(k=0;k<tmp;k++)
//				cvCircle(part[cpt].img,cvPoint((int)part[cpt].tracker->point[k].x,(int)part[cpt].tracker->point[k].y),5,CV_RGB(0,175,0),0);
//			cvShowImage(buffer,part[cpt].img);
			cpt++;
		}
	/* Fusion des tableaux de points */
	img->tracker->point = (CvPoint2D64d*)malloc(sizeof(CvPoint2D64d)*total);
	img->score			= (CvPoint3D64d*)malloc(sizeof(CvPoint3D64d)*total);
//	cvNamedWindow("res",0);
	for(i=0,cpt=0;i<nb;i++)
	{
		I = (i%sub)*img->img->width/sub;
		J = (i/sub)*img->img->height/sub;
		for(j=0;j<part[i].tracker->count ; j++)
		{
			img->tracker->point[cpt].x = part[i].tracker->point[j].x+I;
			img->tracker->point[cpt].y = part[i].tracker->point[j].y+J;
			img->score[cpt].z = part[i].score[j].z;
//			cvCircle(img->img,cvPoint((int)img->tracker->point[cpt].x,(int)img->tracker->point[cpt].y),5,CV_RGB(0,175,0),0);
			cpt++;
		}
	}
	img->tracker->count = total;
//	cvShowImage("res",img->img);
}
void ProcessNormalisation()
{
	NormalisationV2(image[2].img,image[2].scanline,image[2].nbscanline*2,0,image[2].warped,Out );
	NormalisationV2(image[3].img,image[3].scanline,image[3].nbscanline*2,1,image[3].warped,Out );
	
	


	image[2].warped = Normalisation(image[2].img,image[2].scanline,image[2].nbscanline*2,0,image[2].warped,Out );
	image[3].warped = Normalisation(image[3].img,image[3].scanline,image[3].nbscanline*2,1,image[3].warped,Out );
	if(Mode == TEXTE)
	{
		cvSaveImage(Name_output[LEFT],image[2].warped);
		cvSaveImage(Name_output[RIGHT],image[3].warped);
		print(Out,"Ecriture des images redresses %s %s\n",Name_output[LEFT],Name_output[RIGHT]);
		fprintf(Out,"Ecriture des images redresses %s %s\n",Name_output[LEFT],Name_output[RIGHT]);
	}
}

void ScanlineProcess(int indicmorph)
{
	int i;
	CvPoint2D64d *pt1=NULL,*pt2=NULL;
	int size;
	CvPoint2D64d *tab1,*tab2;
	switch(Trackmode)
	{
		case TRACKV1:
			tab1 = image[RIGHT0].tracker->point;
			tab2 = image[LEFT0].tracker->point;
			break;
		case TRACKV2:
			tab1 = image[RIGHT0].tracker->point;
			tab2 = image[LEFT1].tracker->point;
			break;
		case TRACKV3:
			tab1 = image[RIGHT0].tracker->point;
			tab2 = image[LEFT1].tracker->point;
			break;
		case TRACKV4:
			tab1 = image[RIGHT1].tracker->point;
			tab2 = image[LEFT1].tracker->point;
			break;
	}

	/* Recuperation des points cohrents */
	for(i=0,size=0;i<image[LEFT1].tracker->count;i++)
	{
		if(image[LEFT1].score[i].z >= (1+seuil) )
		{
			pt1 = realloc(pt1,sizeof(CvPoint2D64d)*(size+1));
			pt2 = realloc(pt2,sizeof(CvPoint2D64d)*(size+1));
			pt1[size].x = tab1[i].x;
			pt1[size].y = tab1[i].y;
			pt2[size].x = tab2[i].x;
			pt2[size].y = tab2[i].y;
			size++;
		}
	}
	fprintf(Out,"%d points pour la construction des scanlines\n",size);
	/* Construction des scanlines */
	if(!size || !Scanlines(pt1,pt2,&size,Width,Height))
	{
		image[3].nbscanline = 0;
		image[2].nbscanline = 0;
		return;
	}
	/* Recuperation des scanlines */
	image[3].scanline = Convert(image[0].img,0,size,image[3].scanline );
	image[2].scanline = Convert(image[1].img,1,size,image[2].scanline );
	image[3].nbscanline = size;
	image[2].nbscanline = size;
	/* Construction d'une image morphee */
//	if(indicmorph)
//	{
//		morph = Morphing(image[2].img,image[3].img,image[2].nbscanline);
//		fprintf(Out,"Fin de morphing\n");
//	}
	free(pt1);
	free(pt2);
//	Write_Points("Moto.cpj",Name[File][0],Name[File][1],image[0].nbpoints,image[2].point,image[3].point);
	ProcessNormalisation();
}


void TrackProcess(int trackmode)
{
	double duration;
	clock_t start,end;
	start = clock();
//	nbpoints = 10;
	switch(trackmode)
	{
		case TRACKV1:
			/* Initialisation dans la premiere image LEFT(t)	*/
//			InitTracker(image[LEFT0].img,image[LEFT0].tracker,&nbpoints,&image[LEFT0].score);
			InitTrackerBlock(&image[LEFT0],&nbpoints,partition);
			/* Suivi dans la deuxieme image RIGHT(t)			*/
			Track(image[LEFT0].img,image[LEFT0].tracker,&image[LEFT0].score,image[RIGHT0].img,image[RIGHT0].tracker,&image[RIGHT0].score);
			break;
		case TRACKV2:
			/* Initialisation premiere image LEFT(t)	*/
			InitTracker(image[LEFT0].img,image[LEFT0].tracker,&nbpoints,&image[LEFT0].score);
			/* Suiv dans la deuxieme RIGHT(t)			*/
			Track(image[LEFT0].img,image[LEFT0].tracker,&image[LEFT0].score,image[RIGHT0].img,image[RIGHT0].tracker,&image[RIGHT0].score);
			/* Suivi dans la troisieme LEFT(t+1)		*/
			Track(image[RIGHT0].img,image[RIGHT0].tracker,&image[RIGHT0].score,image[LEFT1].img,image[LEFT1].tracker,&image[LEFT1].score);

			/* Slection des points cohrents */
			ComparaisonV2(	image[LEFT0].tracker->point, image[LEFT0].score, 
							image[LEFT1].tracker->point, image[LEFT1].score, 
							nbpoints,seuil);
			break;
		case TRACKV3:
			/* Initialisation premiere image LEFT(t)	*/
			InitTracker(image[LEFT0].img,image[LEFT0].tracker,&nbpoints,&image[LEFT0].score);
			/* Suiv dans la deuxieme RIGHT(t)			*/
			Track(image[LEFT0].img,image[LEFT0].tracker,&image[LEFT0].score,image[RIGHT0].img,image[RIGHT0].tracker,&image[RIGHT0].score);
			/* Initialisation premiere image RIGHT(t+1)	*/
			InitTracker(image[RIGHT1].img,image[RIGHT1].tracker,&nbpoints,&image[RIGHT1].score);

			ComparaisonV3(	image[RIGHT0].tracker->point, image[RIGHT0].score, image[RIGHT0].tracker->count,
							image[RIGHT1].tracker->point, image[RIGHT1].score, image[RIGHT1].tracker->count,seuil);
			break;
		case TRACKV4:
			if(nbpoints == 27)
				nbpoints = 27;
			/* Initialisation Image DROITE 0	*/
			InitTrackerBlock(&image[LEFT0],&nbpoints,partition);
//			InitTracker(image[LEFT0].img,image[LEFT0].tracker,&nbpoints,&image[LEFT0].score);
			/* suivi dans l'image GAUCHE 0		*/
			Track(image[LEFT0].img,image[LEFT0].tracker,&image[LEFT0].score,image[RIGHT0].img,image[RIGHT0].tracker,&image[RIGHT0].score);
			/* Initialisation Image GAUCHE 1	*/
			InitTrackerBlock(&image[RIGHT1],&nbpoints,partition);
//			InitTracker(image[RIGHT1].img,image[RIGHT1].tracker,&nbpoints,&image[RIGHT1].score);
			/* suivi dans l'image DROITE 1		*/
			Track(image[RIGHT1].img,image[RIGHT1].tracker,&image[RIGHT1].score,image[LEFT1].img,image[LEFT1].tracker,&image[LEFT1].score);

			ComparaisonV3(	image[LEFT0].tracker->point,image[LEFT0].score, image[LEFT0].tracker->count,
							image[LEFT1].tracker->point,image[LEFT1].score, image[LEFT1].tracker->count,seuil);

			ComparaisonV3(	image[RIGHT0].tracker->point,image[RIGHT0].score, image[RIGHT0].tracker->count,
							image[RIGHT1].tracker->point,image[RIGHT1].score, image[RIGHT1].tracker->count,
							seuil);
			ComparaisonV4(	image[LEFT0].score,image[LEFT1].score,
							image[RIGHT0].score,image[RIGHT1].score,
							image[LEFT0].tracker->count,image[LEFT1].tracker->count,seuil);
			break;
	}
	end = clock();
	duration = (double)(end - start) / CLOCKS_PER_SEC;
//	printf( "Tps tracking : %2.1f seconds (%d points)\n", duration,nbpoints );
	/* Construction des scanlines */
	ScanlineProcess(0);
}

