#ifndef __TOOLS_H__
#define __TOOLS_H__


#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include <cv.h>
#include <highgui.h>


#include "file.h"
#include "gopt.h"
#include "opengl.h"
#include "tracker.h"
#include "scanline.h"
#include "normalisation.h"

#define TEXTE	0
#define GRAPHIC	1

#define X		0
#define Y		1
#define RIGHT	0
#define LEFT	1
/* Images */
#define LEFT0	0
#define RIGHT0	1
#define LEFT1	2
#define RIGHT1	3
/* Version du suivi de points */
#define TRACKV1	0
#define TRACKV2	1
#define TRACKV3	2
#define TRACKV4	3
/* Couples stroscopique */
#define BASKET		0
#define BUREAU		1
#define CARRE		2
#define CHEERIOS	3
#define CLOROX		4
#define STATUE		5
#define TRUCK		6
#define TSUKUBA		7
#define UMBRELLA	8
#define MOTO		9
#define LOCAL1		10
#define LOCAL2		11
#define TRAIN		12
#define COULOIR		13
#define SOFI1		14
#define SOFI2		15
#define MOTO1		16
/* Nom des couples */
extern char Name[][2][128];
/* Nom des fichiers de sortie */ 

extern char Name_output[2][64];
int		File;			/* Indicateur du couple				*/
float	factor;		/* Facteur de rsolution des images 	*/
int		nbpoints;		/* Nombre de points tracks			*/
int		Trackmode;	/* Version de suivi de points			*/
double	seuil;		/* Seuil de pricision du suivi			*/
int		Modetrack;	/* Version du suivi de pts utiliss		*/
int		partition;		/* Partition par block de l'image		*/
int		Debug;		/* Indicateur de deboggage			*/
FILE		*Out;		/* Descripteur de Debug				*/
int		Mode;		/* Mode graphique ou texte			*/
typedef struct
{
	IplImage		*img;		/* Image						*/
	CvPoint3D64d 	*score;		/* Score des points				*/
	Tracker		*tracker;		/* tracker associ				*/
	CvPoint2D64d	*scanline;
	int			nbscanline;
	IplImage		*warped;
}Image;

Image  image[4];

void		Arguments	(int *argc,char **argv);			/* Gestion des arguments	*/
IplImage *	Resolution	(IplImage *img, float fact);		/* Changement de rsolution */
void		InitTrackerBlock(Image *img, int *nbpoints, int part);
void		IplSetPixel	(IplImage *image,int i_X, int i_Y,uchar R,uchar G,uchar B,int offsetX);
void		IplGetPixel	(IplImage *image,int i_X, int i_Y,uchar *R,uchar *G,uchar *B);

#endif

